import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Serbryt.BandAide";

C_ACTION_LOTRO_HUD_TOGGLE = 268435635
C_ACTION_LOTRO_UI_REPOSITION = 268435579
C_PLUGIN = "BandAide"
C_VERSION = "1.22"

pluginCommand = Turbine.ShellCommand();

local function out(msg)
    Turbine.Shell.WriteLine(msg);
end

function pluginCommand:Execute(cmd, args)
    if (args == "show") then
        mainWindow.shown = true;
        mainWindow:CheckVisible();
    elseif (args == "hide") then
        mainWindow:Hide();
    elseif (args == "reset") then
        mainWindow:Reset();
    elseif (args == "options") then
        mainWindow:ShowOptions();
    elseif (args == "toggle") then
        mainWindow.shown = not mainWindow.shown;
        mainWindow:CheckVisible();
    elseif string.find(string.lower(args), "test ") then
        if string.find(string.lower(args), "addsync") then
            local member, song, instrument, length = string.match(string.lower(args), "test addsync (.+) \"(.+)\" (.+) (%d+%p%d+)");
            if member == nil then
                member, song, instrument = string.match(string.lower(args), "test addsync (.+) \"(.+)\" (.+)");
                if member == nil then
                    member, song = string.match(string.lower(args), "test addsync (.+) \"(.+)\"");
                end
            end
            if member ~= nil and song ~= nil then
                if instrument == nil then
                    instrument = "";
                end
                mainWindow:AddSync(member, song, instrument, GetSongLength(length));
            end
        elseif string.find(string.lower(args), "lostsync") then
            local member = string.match(string.lower(args), "test lostsync (.+)");
            if member ~= nil then
                mainWindow:LostSync(member);
            end
        elseif string.find(string.lower(args), "start") then
            mainWindow:OnMusicStarting();
        else
            out(" Valid test commands are addsync, lostsync or start");
        end
    else
        pluginCommand:GetHelp();
    end
end

function pluginCommand:GetHelp()
    out("BandAide v"..C_VERSION);
    out("  usage: /bandaide [show|hide|toggle|reset|options]");
end

Turbine.Shell.AddCommand("bandaid", pluginCommand);
Turbine.Shell.AddCommand("bandaide", pluginCommand);

out("BandAide v"..C_VERSION.." (/bandaide for more info)");

defaultSettings =
{
    mainwindow =
    {
        position = {left = 0.5, top = 0.5},
    },
    optionswindow =
    {
        position = {left = 0.5, top = 0.5},
    },
    firstload = true,
    hideuntilneeded = true,
    playerbars = true,
    bargrowmode = 0,   -- 0 = smart, 1 = up, 2 = down
    iconsizemode = 0,   -- 0 = smart, 1 = small, 2 = large
    version = C_VERSION,
};

InitLocaleStrings()

settings = PatchDataLoad(Turbine.DataScope.Account, "BandAide") or defaultSettings;

mainWindow = MainWindow();

function chatCallback(sender, args)
    if (args.ChatType ~= Turbine.ChatType.Standard) then
        return;
    end

    ParseChat(mainWindow,args.Message);
end

function unloadCallback()
    settings.firstload = false;
    PatchDataSave(Turbine.DataScope.Account, "BandAide", settings);
    RemoveCallback(Turbine.Chat, "Received", chatCallback);
    Turbine.Shell.RemoveCommand("bandaide");
    Turbine.Shell.RemoveCommand("bandaid");
end

AddCallback(Turbine.Chat, "Received", chatCallback);

plugin.GetOptionsPanel = function( self )
  return OptionsPanel();
end