
OptionsPanel = class(Turbine.UI.Control)

function OptionsPanel:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.hideUntilNeeded = Turbine.UI.Lotro.CheckBox();
    self.hideUntilNeeded:SetParent(self);
    self.hideUntilNeeded:SetText( " Hide Initially" );
    self.hideUntilNeeded:SetChecked(settings.hideuntilneeded);
    self.hideUntilNeeded.CheckedChanged = function( sender, args )
        settings.hideuntilneeded = self.hideUntilNeeded:IsChecked();
    end
    self.hideUntilNeeded:SetPosition(0,0);
    self.hideUntilNeeded:SetSize(150,30);
    self.hideUntilNeeded:SetVisible(true);

    self.playerBars = Turbine.UI.Lotro.CheckBox();
    self.playerBars:SetParent(self);
    self.playerBars:SetText( " Show Player Bars" );
    self.playerBars:SetChecked(settings.playerbars);
    self.playerBars.CheckedChanged = function( sender, args )
        settings.playerbars = self.playerBars:IsChecked();
        mainWindow.activeFrame:RecalcPositionFromBarUpdate();
    end
    self.playerBars:SetPosition(0,30);
    self.playerBars:SetSize(150,40);
    self.playerBars:SetVisible(true);

    self.barModeLabel = Turbine.UI.Label();
    self.barModeLabel:SetParent(self);
    self.barModeLabel:SetPosition(0, 80);
    self.barModeLabel:SetSize(150,20);
    self.barModeLabel:SetText("Bars Grow...");
    self.barModeLabel:SetMouseVisible(false);
    self.barModeLabel:SetVisible(true);

    self.barsSmart = Turbine.UI.Lotro.CheckBox();
    self.barsSmart:SetParent(self);
    self.barsSmart:SetText(" Smart");
    self.barsSmart:SetChecked(settings.bargrowmode == 0);
    self.barsSmart:SetPosition(0,90);
    self.barsSmart:SetSize(80,40);
    self.barsSmart:SetVisible(true);

    self.barsUp = Turbine.UI.Lotro.CheckBox();
    self.barsUp:SetParent(self);
    self.barsUp:SetText(" Up");
    self.barsUp:SetChecked(settings.bargrowmode == 1);
    self.barsUp:SetPosition(100,90);
    self.barsUp:SetSize(80,40);
    self.barsUp:SetVisible(true);

    self.barsDown = Turbine.UI.Lotro.CheckBox();
    self.barsDown:SetParent(self);
    self.barsDown:SetText(" Down");
    self.barsDown:SetChecked(settings.bargrowmode == 2);
    self.barsDown:SetPosition(180,90);
    self.barsDown:SetSize(80,40);
    self.barsDown:SetVisible(true);

    self.barsSmart.CheckedChanged = function( sender, args )
        if self.barsSmart:IsChecked() then
            self:SetBarGrowMode(0);
        end
        self:EnsureBarGrowChecked();
    end
    self.barsUp.CheckedChanged = function( sender, args )
        if self.barsUp:IsChecked() then
            self:SetBarGrowMode(1);
        end
        self:EnsureBarGrowChecked();
    end
    self.barsDown.CheckedChanged = function( sender, args )
        if self.barsDown:IsChecked() then
            self:SetBarGrowMode(2);
        end
        self:EnsureBarGrowChecked();
    end

    self.iconSizesLabel = Turbine.UI.Label();
    self.iconSizesLabel:SetParent(self);
    self.iconSizesLabel:SetPosition(0, 130);
    self.iconSizesLabel:SetSize(150,20);
    self.iconSizesLabel:SetText("Instrument Icons...");
    self.iconSizesLabel:SetMouseVisible(false);
    self.iconSizesLabel:SetVisible(true);

    self.iconSizeSmart = Turbine.UI.Lotro.CheckBox();
    self.iconSizeSmart:SetParent(self);
    self.iconSizeSmart:SetText(" Smart");
    self.iconSizeSmart:SetChecked(settings.iconsizemode == 0);
    self.iconSizeSmart:SetPosition(0,140);
    self.iconSizeSmart:SetSize(80,40);
    self.iconSizeSmart:SetVisible(true);

    self.iconSizeSmall = Turbine.UI.Lotro.CheckBox();
    self.iconSizeSmall:SetParent(self);
    self.iconSizeSmall:SetText(" Small");
    self.iconSizeSmall:SetChecked(settings.iconsizemode == 1);
    self.iconSizeSmall:SetPosition(100,140);
    self.iconSizeSmall:SetSize(80,40);
    self.iconSizeSmall:SetVisible(true);

    self.iconSizeLarge = Turbine.UI.Lotro.CheckBox();
    self.iconSizeLarge:SetParent(self);
    self.iconSizeLarge:SetText(" Large");
    self.iconSizeLarge:SetChecked(settings.iconsizemode == 2);
    self.iconSizeLarge:SetPosition(180,140);
    self.iconSizeLarge:SetSize(80,40);
    self.iconSizeLarge:SetVisible(true);

    self.iconSizeSmart.CheckedChanged = function( sender, args )
        if self.iconSizeSmart:IsChecked() then
            self:SetIconSizeMode(0);
        end
        self:EnsureIconSizeChecked();
    end
    self.iconSizeSmall.CheckedChanged = function( sender, args )
        if self.iconSizeSmall:IsChecked() then
            self:SetIconSizeMode(1);
        end
        self:EnsureIconSizeChecked();
    end
    self.iconSizeLarge.CheckedChanged = function( sender, args )
        if self.iconSizeLarge:IsChecked() then
            self:SetIconSizeMode(2);
        end
        self:EnsureIconSizeChecked();
    end

    self:SetSize(240, 170);
    self:SetMouseVisible(false);
    self:SetVisible(true);

    self.FocusGained = function(sender, args)
        self.playerBars:SetChecked(settings.playerbars);
        self.hideUntilNeeded:SetChecked(settings.hideuntilneeded);
    end
end

function OptionsPanel:EnsureBarGrowChecked()
    if settings.bargrowmode == 0 then
        self.barsSmart:SetChecked(true);
    elseif settings.bargrowmode == 1 then
        self.barsUp:SetChecked(true);
    elseif settings.bargrowmode == 2 then
        self.barsDown:SetChecked(true);
    end
end

function OptionsPanel:EnsureIconSizeChecked()
    if settings.iconsizemode == 0 then
        self.iconSizeSmart:SetChecked(true);
    elseif settings.iconsizemode == 1 then
        self.iconSizeSmall:SetChecked(true);
    elseif settings.iconsizemode == 2 then
        self.iconSizeLarge:SetChecked(true);
    end
end

function OptionsPanel:SetBarGrowMode(mode)
    if mode ~= nil and mode >= 0 and mode <=2 and mode ~= settings.bargrowmode then
        settings.bargrowmode = mode;
        if mode == 0 then
            self.barsSmart:SetChecked(true);
            self.barsUp:SetChecked(false);
            self.barsDown:SetChecked(false);
        elseif mode == 1 then
            self.barsUp:SetChecked(true);
            self.barsSmart:SetChecked(false);
            self.barsDown:SetChecked(false);
        elseif mode == 2 then
            self.barsDown:SetChecked(true);
            self.barsSmart:SetChecked(false);
            self.barsUp:SetChecked(false);
        end
        mainWindow.activeFrame:RecalcPositionFromBarUpdate();
    end
end

function OptionsPanel:SetIconSizeMode(mode)
    if mode ~= nil and mode >= 0 and mode <= 2 and mode ~= settings.iconsizemode then
        settings.iconsizemode = mode;
        if mode == 0 then
            self.iconSizeSmart:SetChecked(true);
            self.iconSizeSmall:SetChecked(false);
            self.iconSizeLarge:SetChecked(false);
        elseif mode == 1 then
            self.iconSizeSmall:SetChecked(true);
            self.iconSizeSmart:SetChecked(false);
            self.iconSizeLarge:SetChecked(false);
        elseif mode == 2 then
            self.iconSizeLarge:SetChecked(true);
            self.iconSizeSmart:SetChecked(false);
            self.iconSizeSmall:SetChecked(false);
        end
        mainWindow.activeFrame:RecalcPositionFromBarUpdate();
    end
end

OptionsWindow = class(Turbine.UI.Lotro.Window);

function OptionsWindow:Constructor()
    Turbine.UI.Lotro.Window.Constructor(self);

    self.hudvisible = true;
    self.repositioning = false;

    self.KeyDown = function(sender, args)
        if (args.Action == C_ACTION_LOTRO_HUD_TOGGLE) then -- HUD toggle
            self.hudvisible = not self.hudvisible;
            self:CheckVisible();
        elseif (args.Action == C_ACTION_LOTRO_UI_REPOSITION) then -- UI element repositioning
            self.repositioning = not self.repositioning;
            self:CheckVisible();
        end
    end

    self:SetWantsKeyEvents(true);

    if type(settings.optionswindow.position.left) == "string" then
        settings.optionswindow.position.left = tonumber(settings.optionswindow.position.left);
    end
    if type(settings.optionswindow.position.top) == "string" then
        settings.optionswindow.position.top = tonumber(settings.optionswindow.position.top);
    end
    if type(settings.optionswindow.position.left) == "string" then
        settings.optionswindow.position.left = tonumber(settings.optionswindow.position.left);
    end
    if type(settings.optionswindow.position.top) == "string" then
        settings.optionswindow.position.top = tonumber(settings.optionswindow.position.top);
    end

    settings.optionswindow.position.left = math.max(0, math.min(0.95, settings.optionswindow.position.left));
    settings.optionswindow.position.top = math.max(0, math.min(0.95, settings.optionswindow.position.top));

    self:SetText("BandAide Options");

    self.options = OptionsPanel(self);
    self.options:SetParent(self);
    self.options:SetPosition(40, 40);
    self.options:SetVisible(true);
    self:SetZOrder(mainWindow:GetZOrder()+1);

    self:UpdatePosition(Turbine.UI.Display:GetWidth()*settings.optionswindow.position.left,
                        Turbine.UI.Display:GetHeight()*settings.optionswindow.position.top,
                        self.options:GetWidth() + 80,
                        self.options:GetHeight() + 80);

    self.Closing = function(sender, args) self.shown = false; end
end


function OptionsWindow:CheckVisible()
    self:SetVisible(self.shown and self.hudvisible and not self.repositioning);
end

function OptionsWindow:UpdatePosition(x,y,w,h)
    local newW = math.min(w,Turbine.UI.Display:GetWidth()*0.8);
    local newX = math.max(10, math.min(x,Turbine.UI.Display:GetWidth()-newW-10));
    local newH = math.min(h,Turbine.UI.Display:GetHeight()*0.8);
    local newY = math.max(10, math.min(y,Turbine.UI.Display:GetHeight()-newH-10));
    self:SetPosition(newX,newY);
    self:SetSize(newW,newH);
end
